addpath ~/lab/tensor_toolbox
addpath ~/lab/tensor_toolbox/algorithms


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% test unsymmetric tensor
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
A = tenrand([20 16 10 32]);
r = 5;
opts = struct('tol',1e-5, 'maxiter',1000, 'init','nvecs');
[T, normT, difU] = lroat(A, r, opts);

semilogy(difU(:,1),'r');
hold on
semilogy(difU(:,2),'g');
semilogy(difU(:,3),'b');
semilogy(difU(:,4),'c');
hold off


%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
% test symmetric tensor
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
n = 10;
A = tenzeros([n n n]);
for i = 1:n
  for j = 1:n
    for k = 1:n
      A(i,j,k) = 1/(i^2+j^2+k^2);
    end
  end
end
r = 5;
opts = struct('tol',1e-5, 'maxiter',1000, 'init','nvecs');
[T, normT, difU] = lroatsym(A, r, opts);

figure;
semilogy(difU(:,1));
